package com.dr.plugins.example;

import static android.content.ContentValues.TAG;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.util.Base64;
import android.util.Log;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

/**
 * file <<>> Base64String
 * 将file文件转换为Base64<br>
 * 将base64编码字符串解码成file
 * @author wy
 *
 */
public class FileBase64BitmapUtil {

    public static void main(String[] args) {
        String imgFile = "d:\\1.jpg";//待处理的图片
        String imgbese=getFileBase64StrByLocalFile(imgFile);
        System.out.println(imgbese.length());
        System.out.println(imgbese);
        String imgFilePath = "d:\\332.jpg";//新生成的图片
        String imgStr="";
        generateBase64StringToFile(imgStr,imgFilePath);
    }

    //本地文件转为Base64字符串，localFilePath为文件路径
    public static String getFileBase64StrByLocalFile(String localFilePath){
        InputStream in = null;
        byte[] data = null;
        //读取图片字节数组
        try
        {
            in = new FileInputStream(localFilePath);
            data = new byte[in.available()];
            in.read(data);
            in.close();
        }
        catch (IOException e)
        {
            e.printStackTrace();
        }
        //return new String(Base64.encodeBase64(data));
        return new String(Base64.encode(data,Base64.NO_WRAP));
    }

    //Base64字符串转为文件，base64为字符串，filaName为保存的文件名称，savePath为保存路径
    public static void base64ToFile(String base64, String fileName, String savePath) {
        File file = null;
        //创建文件目录
        String filePath = savePath;
        File dir = new File(filePath);
        if (!dir.exists() && !dir.isDirectory()) {
            dir.mkdirs();
        }
        BufferedOutputStream bos = null;
        java.io.FileOutputStream fos = null;
        try {
            byte[] bytes = Base64.decode(base64,Base64.NO_WRAP);
            file=new File(filePath + fileName);
            fos = new java.io.FileOutputStream(file);
            bos = new BufferedOutputStream(fos);
            bos.write(bytes);
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (bos != null) {
                try {
                    bos.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            if (fos != null) {
                try {
                    fos.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
    }

    //Base64转为Bitmap
    public static Bitmap base64ToBitmap(String base64String) {
        byte[] decode = Base64.decode(base64String.replace("data:image/png;base64,", "").trim(),Base64.NO_WRAP);
        Bitmap bitmap = BitmapFactory.decodeByteArray(decode, 0, decode.length);
        return bitmap;
    }
    //保存Bitmap文件到指定路径
    public  void saveBitmap(Bitmap bitmap, String storePath) {
        Log.e(TAG, "保存图片");
        File f = new File(storePath);
        if (f.exists()) {
            f.delete();
        }
        try {
            FileOutputStream out = new FileOutputStream(f);
            bitmap.compress(Bitmap.CompressFormat.PNG, 90, out);
            out.flush();
            out.close();
            Log.i(TAG, "已经保存");
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * 对字节数组字符串进行Base64解码并生成图片
     * @param fileStr 图片数据
     * @param fileFilePath 保存图片全路径地址
     * @return
     */
    public static void generateBase64StringToFile(String fileStr,String fileFilePath){
        if (fileStr == null) //图像数据为空

            try
            {
                //Base64解码
                byte[] b = Base64.decode(fileStr,Base64.NO_WRAP);
                for(int i=0;i<b.length;++i)
                {
                    if(b[i]<0)
                    {//调整异常数据
                        b[i]+=256;
                    }
                }
                //生成jpeg图片
                OutputStream out = new FileOutputStream(fileFilePath);
                out.write(b);
                out.flush();
                out.close();

            }
            catch (Exception e)
            {

            }
    }
}
